{       ,   ᠬ ࠧ  ⮩ ணࠬ.
          㦥 SVGA256.BGI ( ਫ ).
        ⫥  뫠   denis@mpsau.ozon.msk.ru.
}
uses Dos, Graph, Crt;

var
  GraphDriver:       Integer;  { The Graphics device driver }
  GraphMode:         Integer;  { The Graphics mode value }
  MaxX, MaxY:        Word;     { The maximum resolution of the screen }
  ErrorCode:         Integer;  { Reports any graphics errors }
  MaxColor:          Word;     { The maximum color value available }
  OldExitProc:       Pointer;  { Saves exit procedure address }
  AutoDetectPointer: Pointer;

{$F+}
procedure MyExitProc;
begin
  ExitProc := OldExitProc; { Restore exit procedure address }
  CloseGraph;              { Shut down the graphics system }
end; { MyExitProc }
{$F-}

procedure Mode256;
{$F+}
function DetectVGA256 : integer;
{ Detects VGA or MCGA video cards }
var
  DetectedDriver, SuggestedMode: integer;
begin
  DetectGraph(DetectedDriver, SuggestedMode);
  if (DetectedDriver = VGA) or (DetectedDriver = MCGA) then
    DetectVGA256 := {SuggestedMode}3
  else
    DetectVGA256 := grError; { Couldn't detect hardware }
end; { DetectVGA256 }
{$F-}
{ Initialize graphics and report any errors that may occur }
var
  InGraphicsMode : boolean; { Flags initialization of graphics mode }
  PathToDriver   : string;  { Stores the DOS path to *.BGI & *.CHR }
begin
  { when using Crt and graphics, turn off Crt's memory-mapped writes }
  DirectVideo := False;
  OldExitProc := ExitProc;                { save previous exit proc }
  ExitProc := @MyExitProc;                { insert our exit proc in chain }
  PathToDriver := '';
  repeat
    AutoDetectPointer := @DetectVGA256;
    GraphDriver := InstallUserDriver('Svga256',AutoDetectPointer);
    GraphDriver := Detect;
    InitGraph(GraphDriver, GraphMode, PathToDriver);
    ErrorCode := GraphResult;             { preserve error return }
    if ErrorCode <> grOK then             { error? }
    begin
      Writeln('Graphics error: ', GraphErrorMsg(ErrorCode));
      if ErrorCode = grFileNotFound then  { Can't find driver file }
      begin
        Writeln('Enter full path to BGI driver or type <Ctrl-Break> to quit:');
        Readln(PathToDriver);
        Writeln;
      end
      else
        Halt(1);                          { Some other error: terminate }
    end;
  until ErrorCode = grOK;
  Randomize;                { init random number generator }
  MaxColor := GetMaxColor;  { Get the maximum allowable drawing color }
  MaxX := GetMaxX;          { Get screen resolution values }
  MaxY := GetMaxY;
end; { Mode256 }

const
  X = 250;
  Y = 250;
type
  TBuffArr = Array [1..X, 1..Y] of Char;
  PBuffArr = ^TBuffArr;
var
  F: Text;
  Ch: Char;
  Size, I, J, P: Integer;
  Buffer: PBuffArr;

procedure DrawCircle;
begin
  For I := 1 to X div 2 do
    begin
      SetColor(I);
      Ellipse(X div 2, Y div 2, 0, 360, I div 2, I);
    end;
end;

procedure CopyCircleToBuffer;
begin
  For I := 1 to X do
    For J := 1 to Y do
      begin
        P := GetPixel(I, J);
        Ch := Chr(P + 96);
        Buffer^[I, J] := Ch;
      end;
end;

procedure CopyBufferToFile;
begin
  Assign(F, 'Circle.Img');
  ReWrite(F);
  For I := 1 to X do
    begin
      For J := 1 to Y do
        Write(F, Buffer^[I, J]);
      WriteLn(F);
    end;
  Close(F);
end;

begin
  Mode256;
  {}
  New(Buffer);
  {}
  DrawCircle;
  CopyCircleToBuffer;
  CopyBufferToFile;
  {}
  Dispose(Buffer);
  {}
  WriteLn('Press Enter for Exit.');
  ReadLn;
  {}
  CloseGraph;
end.


